'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Mavigator = function () {
    function Mavigator() {
        var selector = arguments.length <= 0 || arguments[0] === undefined ? 'html' : arguments[0];
        var options = arguments[1];

        _classCallCheck(this, Mavigator);

        this.selector = selector;
        this.options = this.mergeOptions(Mavigator.defaults(), options);
    }

    _createClass(Mavigator, [{
        key: 'mergeOptions',
        value: function mergeOptions(source, override) {
            for (var key in override) {
                if (source.hasOwnProperty(key)) {
                    source[key] = override[key];
                }
            }

            return source;
        }
    }, {
        key: 'init',
        value: function init() {
            var _this = this;

            var nodes = this.getNodesToMark();

            if (!nodes || !nodes.length) {
                if (this.options.warn) {
                    console.warn('No link to mark was found for the given URI [' + this.options.uri + ']');
                }
                return;
            }

            nodes.forEach(function (node) {
                var realNode = _this.options.classToParent ? node.parentNode : node;

                _this.addClassTo(realNode);
            });
        }
    }, {
        key: 'getNodesToMark',
        value: function getNodesToMark() {
            var _this2 = this;

            var nodes = [];
            var sets = this.sets();

            if (!sets.length) return;

            sets.forEach(function (set) {
                return nodes = nodes.concat(_this2.getMarkableNodesFrom(set));
            });

            return nodes;
        }
    }, {
        key: 'sets',
        value: function sets() {
            this.validateSelector();

            return document.querySelectorAll(this.selector);
        }
    }, {
        key: 'validateSelector',
        value: function validateSelector() {
            if (!this.selector.length) {
                throw new TypeError('The provided selector is empty.');
            }

            if (_typeof(this.selector) === 'object') {
                throw new TypeError('A selector must be a string.');
            }
        }
    }, {
        key: 'getMarkableNodesFrom',
        value: function getMarkableNodesFrom(set) {
            var _this3 = this;

            var selector = 'a';
            var links = set.querySelectorAll(selector);
            links = [].slice.call(links);

            return links.filter(function (link) {
                return link.pathname === _this3.options.uri;
            });
        }
    }, {
        key: 'addClassTo',
        value: function addClassTo(node) {
            if (node.classList) {
                node.classList.add(this.options.className);
            } else {
                node.className += ' ' + className;
            }
        }
    }], [{
        key: 'mark',
        value: function mark(selector, options) {
            new Mavigator(selector, options).init();
        }
    }, {
        key: 'defaults',
        value: function defaults() {
            return {
                className: 'active',
                classToParent: false,
                uri: window.location.pathname,
                warn: false
            };
        }
    }]);

    return Mavigator;
}();

exports.default = Mavigator;